--- C:/Users/Murray/AppData/Local/Temp/res_agi.-revBASE.svn001.tmp.c	Thu May  5 09:56:26 2011
+++ C:/sandbox/vendor-trunk/asterisk-1.6.2.18/res/res_agi.c	Thu May  5 09:55:30 2011
@@ -1154,9 +1154,10 @@
 static int handle_controlstreamfile(struct ast_channel *chan, AGI *agi, int argc, char *argv[])
 {
 	int res = 0, skipms = 3000;
+	long offsetms = 0;
 	char *fwd = "#", *rev = "*", *suspend = NULL, *stop = NULL;	/* Default values */
 
-	if (argc < 5 || argc > 9) {
+	if (argc < 5 || argc > 10) {
 		return RESULT_SHOWUSAGE;
 	}
 
@@ -1180,10 +1181,14 @@
 		suspend = argv[8];
 	}
 
-	res = ast_control_streamfile(chan, argv[3], fwd, rev, stop, suspend, NULL, skipms, NULL);
+	if (argc > 9 &&(sscanf(argv[9], "%30ld", &offsetms) != 1)) {
+		return RESULT_SHOWUSAGE;
+	}
 
-	ast_agi_send(agi->fd, chan, "200 result=%d\n", res);
+	res = ast_control_streamfile(chan, argv[3], fwd, rev, stop, suspend, NULL, skipms, &offsetms);
 
+	ast_agi_send(agi->fd, chan, "200 result=%d endpos=%ld\n", res, offsetms);
+
 	return (res >= 0) ? RESULT_SUCCESS : RESULT_FAILURE;
 }
 
@@ -2347,13 +2352,14 @@
 " extension must not be included in the filename.\n";
 
 static char usage_controlstreamfile[] =
-" Usage: CONTROL STREAM FILE <filename> <escape digits> [skipms] [ffchar] [rewchr] [pausechr]\n"
+" Usage: CONTROL STREAM FILE <filename> <escape digits> [skipms] [ffchar] [rewchr] [pausechr] [offsetms]\n"
 "	Send the given file, allowing playback to be controled by the given\n"
 " digits, if any. Use double quotes for the digits if you wish none to be\n"
-" permitted.  Returns 0 if playback completes without a digit\n"
+" permitted.  If offsetms is provided then the audio will seek to offsetms\n"
+" before play starts.  Returns 0 if playback completes without a digit\n"
 " being pressed, or the ASCII numerical value of the digit if one was pressed,\n"
-" or -1 on error or if the channel was disconnected. Remember, the file\n"
-" extension must not be included in the filename.\n\n"
+" or -1 on error or if the channel was disconnected. Returns the position where\n"
+" playback was terminated as endpos.  Remember, the file extension must not be\n"
 " Note: ffchar and rewchar default to * and # respectively.\n";
 
 static char usage_saynumber[] =
